(* stringinstream.sml *)

structure StringInstream :> INSTREAM =
struct
   type instream = {base: string, pos: int, limit: int}

   fun fromString string = {base=string, pos=0, limit=size string}

   fun inputc {base,pos,limit} = 
       if pos >= limit then NONE
       else SOME(String.sub(base,pos), {base=base,pos=pos+1,limit=limit})

end (* structure StringInstream *)

