(* streaminstream.sml *)

structure StreamInStream :> INSTREAM where type instream = char Stream.stream =
struct
  open Stream

  type instream = char stream
  
  fun fromString string = raise Fail "unimplemented"

  fun inputc s =
      if snull s then NONE
      else let val (c,s') = sdest s in SOME(c,s) end

end (* structure StreamInstream *)


structure TextFileStream =
struct

  fun mkFileStream filename = 
      let val ins = TextIO.openIn filename
          fun f () = Stream.scons(TextIO.input1 ins, Stream.mkStream f)
       in Stream.mkStream f
      end

end  (* structure TextFileStream *)
